#!/bin/bash

###
# This script is used to test the post-update hook
#
# This script is part of frank-ci, it is disributed under the terms of GPLv3 or
# later.
#
# Copyright Oz N Tiram <oz.tiram@gmail.com>
# 
##

function generate_junk(){
   for i in seq 1 3; do
       echo $(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 32 | head -n 1) > bla 
       git commit -a -m "test `date`" 
   done 
}

git checkout master
generate_junk
git checkout dev
git checkout master
git push --all
